/*
  ==============================================================================

    This file was auto-generated!

    It contains the basic framework code for a JUCE plugin editor.

  ==============================================================================
*/

#include "PluginProcessor.h"
#include "PluginEditor.h"

//==============================================================================
slovikp04AudioProcessorEditor::slovikp04AudioProcessorEditor (slovikp04AudioProcessor& p)
    : AudioProcessorEditor (&p), processor (p)
{
    
    MyBackground = ImageCache::getFromMemory(BinaryData::delayBackground_jpg, BinaryData::delayBackground_jpgSize);
    
    // delay time L
    delayTimeL.setRange(0.0, 2000.0, 1.0);
    delayTimeL.setSliderStyle(Slider::RotaryVerticalDrag);
    delayTimeL.setTextValueSuffix("ms");
    delayTimeL.setTextBoxStyle(Slider::TextBoxBelow, false, 75, 20);
    delayTimeL.addListener(this);
    addAndMakeVisible(delayTimeL);
    // label design
    dtlLabel.setText("Left", dontSendNotification);
    dtlLabel.attachToComponent(&delayTimeL, false);
    dtlLabel.setFont(Font(15.0));
    dtlLabel.setJustificationType(Justification::centredTop);
    addAndMakeVisible(dtlLabel);
    
    // delay time R
    delayTimeR.setRange(0.0, 2000.0, 1.0);
    delayTimeR.setSliderStyle(Slider::RotaryVerticalDrag);
    delayTimeR.setTextValueSuffix("ms");
    delayTimeR.setTextBoxStyle(Slider::TextBoxBelow, false, 75, 20);
    delayTimeR.addListener(this);
    addAndMakeVisible(delayTimeR);
    // label design
    dtrLabel.setText("Right", dontSendNotification);
    dtrLabel.attachToComponent(&delayTimeR, false);
    dtrLabel.setFont(Font(15.0));
    dtrLabel.setJustificationType(Justification::centredTop);
    addAndMakeVisible(dtrLabel);
    
    // output gain
    outGain.setRange(-6.0, 6.0, 0.1);
    outGain.setSliderStyle(Slider::LinearBarVertical);
    outGain.setTextValueSuffix("dB");
    outGain.setTextBoxStyle(Slider::TextBoxBelow, false, 60, 20);
    outGain.addListener(this);
    addAndMakeVisible(outGain);
    // label design
    oGLabel.setText("Out", dontSendNotification);
    oGLabel.attachToComponent(&outGain, false);
    oGLabel.setFont(Font(15.0));
    oGLabel.setJustificationType(Justification::centredTop);
    addAndMakeVisible(oGLabel);
    
    // input gain
    inGain.setRange(-6.0, 6.0, 0.1);
    inGain.setSliderStyle(Slider::LinearBarVertical);
    inGain.setTextValueSuffix("dB");
    inGain.setTextBoxStyle(Slider::TextBoxBelow, false, 60, 20);
    inGain.addListener(this);
    addAndMakeVisible(inGain);
    // label design
    iGLabel.setText("In", dontSendNotification);
    iGLabel.attachToComponent(&inGain, false);
    iGLabel.setFont(Font(15.0));
    iGLabel.setJustificationType(Justification::centredTop);
    addAndMakeVisible(iGLabel);
    
    // delay dry / wet mix
    dryWet.setRange(0.0, 100.0, 0.1);
    dryWet.setSliderStyle(Slider::RotaryVerticalDrag);
    dryWet.setTextValueSuffix("%");
    dryWet.setTextBoxStyle(Slider::TextBoxBelow, false, 60, 20);
    dryWet.addListener(this);
    addAndMakeVisible(dryWet);
    // dry wet label design
    dwLabel.setText("Delay", dontSendNotification);
    dwLabel.attachToComponent(&dryWet, false);
    dwLabel.setFont(Font(15.0));
    dwLabel.setJustificationType(Justification::centredTop);
    addAndMakeVisible(dwLabel);
    
    // delay feedback
    fb.setRange(0.0, 99.0, 0.1);
    fb.setSliderStyle(Slider::RotaryVerticalDrag);
    fb.setTextValueSuffix("%");
    fb.setTextBoxStyle(Slider::TextBoxBelow, false, 60, 20);
    fb.addListener(this);
    addAndMakeVisible(fb);
    // label design
    fbLabel.setText("Feedback", dontSendNotification);
    fbLabel.attachToComponent(&fb, false);
    fbLabel.setFont(Font(15.0));
    fbLabel.setJustificationType(Justification::centredTop);
    addAndMakeVisible(fbLabel);
    
    // link button
    addAndMakeVisible (&linkButton);
    linkButton.setButtonText ("Link");
    linkButton.addListener (this);
    linkButton.setClickingTogglesState(true);
    
    // shimmer
    shimmer.setRange(0.0, 100.0, 0.1);
    shimmer.setSliderStyle(Slider::RotaryVerticalDrag);
    shimmer.setTextValueSuffix("%");
    shimmer.setTextBoxStyle(Slider::TextBoxBelow, false, 60, 20);
    shimmer.addListener(this);
    addAndMakeVisible(shimmer);
    // label design
    shimLabel.setText("Shimmer", dontSendNotification);
    shimLabel.attachToComponent(&shimmer, false);
    shimLabel.setFont(Font(15.0));
    shimLabel.setJustificationType(Justification::centredTop);
    addAndMakeVisible(shimLabel);
    
    // modulation rate (sent to delay time)
    mRate.setRange(0.0, 20.0, 0.001);
    mRate.setSliderStyle(Slider::RotaryVerticalDrag);
    mRate.setTextValueSuffix(" Hz");
    mRate.setTextBoxStyle(Slider::TextBoxBelow, false, 60, 20);
    mRate.addListener(this);
    addAndMakeVisible(mRate);
    // label design
    mrLabel.setText("Mod Rate", dontSendNotification);
    mrLabel.attachToComponent(&mRate, false);
    mrLabel.setFont(Font(15.0));
    mrLabel.setJustificationType(Justification::centredTop);
    addAndMakeVisible(mrLabel);
    
    // chorus depth
    depth.setRange(0.0, 100.0, 0.1);
    depth.setSliderStyle(Slider::RotaryVerticalDrag);
    depth.setTextValueSuffix("%");
    depth.setTextBoxStyle(Slider::TextBoxBelow, false, 60, 20);
    depth.addListener(this);
    addAndMakeVisible(depth);
    // label design
    depLabel.setText("Depth", dontSendNotification);
    depLabel.attachToComponent(&depth, false);
    depLabel.setFont(Font(15.0));
    depLabel.setJustificationType(Justification::centredTop);
    addAndMakeVisible(depLabel);
    
    // chorus rate
    rate.setRange(0.0, 20.0, 0.001);
    rate.setSliderStyle(Slider::RotaryVerticalDrag);
    rate.setTextValueSuffix(" Hz");
    rate.setTextBoxStyle(Slider::TextBoxBelow, false, 60, 20);
    rate.addListener(this);
    addAndMakeVisible(rate);
    // label design
    rateLabel.setText("Rate", dontSendNotification);
    rateLabel.attachToComponent(&rate, false);
    rateLabel.setFont(Font(15.0));
    rateLabel.setJustificationType(Justification::centredTop);
    addAndMakeVisible(rateLabel);
    
    // chrous feedback
    chorusFb.setRange(0.0, 99.0, 0.1);
    chorusFb.setSliderStyle(Slider::RotaryVerticalDrag);
    chorusFb.setTextValueSuffix("%");
    chorusFb.setTextBoxStyle(Slider::TextBoxBelow, false, 60, 20);
    chorusFb.addListener(this);
    addAndMakeVisible(chorusFb);
    // label design
    chorusFbLabel.setText("Feedback", dontSendNotification);
    chorusFbLabel.attachToComponent(&chorusFb, false);
    chorusFbLabel.setFont(Font(14.0));
    chorusFbLabel.setJustificationType(Justification::centredTop);
    addAndMakeVisible(chorusFbLabel);
    
    // chrous dry wet mix
    chorusDw.setRange(0.0, 99.0, 0.1);
    chorusDw.setSliderStyle(Slider::RotaryVerticalDrag);
    chorusDw.setTextValueSuffix("%");
    chorusDw.setTextBoxStyle(Slider::TextBoxBelow, false, 60, 20);
    chorusDw.addListener(this);
    addAndMakeVisible(chorusDw);
    // label design
    chorusDwLabel.setText("Chorus", dontSendNotification);
    chorusDwLabel.attachToComponent(&chorusDw, false);
    chorusDwLabel.setFont(Font(15.0));
    chorusDwLabel.setJustificationType(Justification::centredTop);
    addAndMakeVisible(chorusDwLabel);
    
    
    // Make sure that before the constructor has finished, you've set the
    // editor's size to whatever you need it to be.
    setSize (960, 385);
    startTimer(100); //for the UI
}

slovikp04AudioProcessorEditor::~slovikp04AudioProcessorEditor()
{
}

//==============================================================================
void slovikp04AudioProcessorEditor::paint (Graphics& g)
{
    // (Our component is opaque, so we must completely fill the background with a solid colour)
    g.fillAll (getLookAndFeel().findColour (ResizableWindow::backgroundColourId));
    g.drawImageAt(MyBackground, 0, 0);
    g.setColour (Colours::white);
    getLookAndFeel().setColour (Slider::thumbColourId, Colours::violet);
    g.setFont (25.0f);
    g.drawFittedText ("Delaze", getLocalBounds(), Justification::centredTop, 1);
    g.setFont (17.0f); // set delay time font size
    g.drawSingleLineText("Delay Time", 195, 90, Justification::centred);
    g.fillRect(327,193,350,1); // line dividing controls
    g.setFont(14.0f); // set chorus controls font size
    g.drawSingleLineText("Chorus Controls", 500, 210, Justification::centred);
    g.drawRect(730,55,95,299); // rectangle around mix controls
    g.setFont(20.0f); // set Mix font size
    g.drawSingleLineText("Mix", 777, 50, Justification::centred);
    g.drawRect(90,110,210,183); // rectangle around delay time controls
}

void slovikp04AudioProcessorEditor::resized()
{
    // This is generally where you'll want to lay out the positions of any
    // subcomponents in your editor..
    int x = 20; int y = 80; int w = 100; int h = 100; int sp = 30; // space variable
    // linear bar sizing
    int ww = 40; int hh = 260;
    
    // left side
    inGain.setBounds(x, y-10, ww, hh);
    
    // row 1, left to right
    delayTimeL.setBounds(x+ww+sp, y+(sp*2), w, h);
    delayTimeR.setBounds(x+ww+w+sp+10, y+(sp*2), w, h);
    linkButton.setBounds(x+ww+w+15, y+h+(sp*2)+10, 46, 21); // between & below L and R
    fb.setBounds(x+ww+((w+sp)*2), y, w, h);
    shimmer.setBounds(x+ww+((w+sp)*3), y, w, h);
    mRate.setBounds(x+ww+((w+sp)*4), y, w, h);
    
    // row 2, left to right
    depth.setBounds(x+ww+((w+sp)*2), y+h+(sp*2)+5, w, h);
    rate.setBounds(x+ww+((w+sp)*3), y+h+(sp*2)+5, w, h);
    chorusFb.setBounds(x+ww+((w+sp)*4), y+h+(sp*2)+5, w, h);
    
    // dry wet column
    dryWet.setBounds(10+x+ww+((w+sp)*5), y, w+15, h+15);
    chorusDw.setBounds(10+x+ww+((w+sp)*5), y+h+15+sp, w+15, h+10);
    
    // right side
    outGain.setBounds(20+x+ww+((w+sp)*6), y-10, ww, hh);

}

//This gets called whenever the user moves a slider
void slovikp04AudioProcessorEditor::sliderValueChanged(Slider* slider)
{
    
    // Mu45Param: make an additional "else if" for each slider
    if (slider == &delayTimeL) {
        *processor.delayTimeLUParam = (float) delayTimeL.getValue();
    }
    
    else if (slider == &delayTimeR) {
        *processor.delayTimeRUParam = (float) delayTimeR.getValue();
    }
    
    else if (slider == &outGain) {
        *processor.oGainUParam = (float) outGain.getValue();
    }
    
    else if (slider == &inGain) {
        *processor.iGainUParam = (float) inGain.getValue();
    }
    
    else if (slider == &dryWet) {
        *processor.dryWetUParam = (float) dryWet.getValue();
    }
    
    else if (slider == &fb) {
        *processor.fbUParam = (float) fb.getValue();
    }
    
//    else if (slider == &shimmer) {
//        *processor.shimUParam = (float) shimmer.getValue();
//    }
//
//    else if (slider == &mRate) {
//        *processor.mRate = (float) mRate.getValue();
//    }
//
//    else if (slider == &chorusDw) {
//        *processor.chorusDwUParam = (float) chorusDw.getValue();
//    }
//
//    else if (slider == &depth) {
//        *processor.depthUParam = (float) depth.getValue();
//    }
//
//    else if (slider == &rate) {
//        *processor.LFOrate = (float) rate.getValue();
//    }
//
//    else if (slider == &ChorusFb) {
//        *processor.chorusFbUParam = (float) chorusFb.getValue();
//    }
    
}

void slovikp04AudioProcessorEditor::buttonClicked (Button* buttonThatWasClicked)
{
    // This is generally where you'll want to lay out the positions of any
    // subcomponents in your editor..
    if (buttonThatWasClicked == &linkButton)
    {
        *processor.link = (float) linkButton.getToggleState(); //alternates between 0 and 1.
        //show user that something happened.
        if (*processor.link == 1) {
            linkButton.setButtonText ("Link");
        } else {
            linkButton.setButtonText ("Unlink");
        }
    }
}

//This gets called every N msec so that sliders can update their value if the host changed them using parameter automation
void slovikp04AudioProcessorEditor::timerCallback()
{
    //Update the value of each slider to match the value in the Processor
    if (*processor.link == 1) {
        delayTimeL.setValue(*processor.delayTimeLUParam, dontSendNotification);
        delayTimeR.setValue(*processor.delayTimeRUParam, dontSendNotification);
    } else {
        delayTimeL.setValue(*processor.delayTimeLUParam, dontSendNotification);
        delayTimeR.setValue(*processor.delayTimeLUParam, dontSendNotification);
    }
    //delayTimeL.setValue(*processor.delayTimeLUParam, dontSendNotification);
    //delayTimeR.setValue(*processor.delayTimeRUParam, dontSendNotification);
    outGain.setValue(*processor.oGainUParam, dontSendNotification);
    inGain.setValue(*processor.iGainUParam, dontSendNotification);
    dryWet.setValue(*processor.dryWetUParam, dontSendNotification);
    fb.setValue(*processor.fbUParam, dontSendNotification);
    linkButton.setToggleState(*processor.link, dontSendNotification);
    //someOtherSlider->setValue(processor.someOtherUserParameter->getActualValue(), dontSendNotification);
}

