/*
  ==============================================================================

    This file was auto-generated!

    It contains the basic framework code for a JUCE plugin processor.

  ==============================================================================
*/

#pragma once

#include "../JuceLibraryCode/JuceHeader.h"
#include "stk/DelayL.h"

//==============================================================================
/**
*/
class slovikp04AudioProcessor  : public AudioProcessor
{
public:
    //==============================================================================
    slovikp04AudioProcessor();
    ~slovikp04AudioProcessor();

    //==============================================================================
    void prepareToPlay (double sampleRate, int samplesPerBlock) override;
    void releaseResources() override;

   #ifndef JucePlugin_PreferredChannelConfigurations
    bool isBusesLayoutSupported (const BusesLayout& layouts) const override;
   #endif

    void processBlock (AudioBuffer<float>&, MidiBuffer&) override;

    //==============================================================================
    AudioProcessorEditor* createEditor() override;
    bool hasEditor() const override;

    //==============================================================================
    const String getName() const override;

    bool acceptsMidi() const override;
    bool producesMidi() const override;
    bool isMidiEffect() const override;
    double getTailLengthSeconds() const override;

    //==============================================================================
    int getNumPrograms() override;
    int getCurrentProgram() override;
    void setCurrentProgram (int index) override;
    const String getProgramName (int index) override;
    void changeProgramName (int index, const String& newName) override;

    //==============================================================================
    void getStateInformation (MemoryBlock& destData) override;
    void setStateInformation (const void* data, int sizeInBytes) override;
    
    //Add a public pointer for each user parameter
    AudioParameterFloat* delayTimeLUParam;
    AudioParameterFloat* delayTimeRUParam;
    AudioParameterFloat* oGainUParam;
    AudioParameterFloat* iGainUParam;
    AudioParameterFloat* dryWetUParam;
    AudioParameterFloat* fbUParam;
    AudioParameterFloat* link;

private:
    
    void calcAlgorithmParams();
    //Create other variables you will need, such as algorithm parameters
    
    float gain; // holds a linear gain value to allow for multiple gains
    
    // gain params
    float oGainAParam; // calculation of out gain parameter
    float iGainAParam; // calculation of gry gain parameter
    // delay mix params
    float dryWetAParam; // dry and wet knob
    float dGain; // variable to hold dry gain value
    float wGain; // variable to hold wet gain value
    
    // delay feedback
    float fbAParam; // delay.nextOut() * fbGain
    float fbGL, fbGR; // variables to hold left and right feedback
    
    // delay params
    float fs; // need sample rate ro calculate delay
    float calcDelaySampsFromMsec(float msec); // function to be used for conversion
    float leftDelayMsec, rightDelayMsec;
    float delaySampsL, delaySampsR; // variable to store our delay in samples
    int maxDelayInSamps; // max amount of memory to store delay
    stk::DelayL delayL, delayR;   // reference to the stk delay, creating a variable called delay
    
    // interpolation stuff
    float curDelayL, prevDelayL, curDelayR, prevDelayR; // variables to hold current and previous delay time
    float linInterpolation(float start, float end, float fract); // linear interpolation function
    
    //==============================================================================
    JUCE_DECLARE_NON_COPYABLE_WITH_LEAK_DETECTOR (slovikp04AudioProcessor)
};
